<? /*

Installation script for XPDK-based projects

(C) 2006 XXXX Pro, United Open Project
Visit us online: http://openproj.ru

*/

require("install.inc");

function &getvar($name) {
  if (strpos($name,"_text")===false) {
    if (isset($_GET[$name])) $tmp = addslashes($_GET[$name]);
    elseif (isset($_POST[$name])) $tmp= addslashes($_POST[$name]);
  }
  else {
    if (isset($_GET[$name])) $tmp = htmlspecialchars(addslashes($_GET[$name]));
    elseif (isset($_POST[$name])) $tmp= htmlspecialchars(addslashes($_POST[$name]));
  }
  return $tmp;
}

//   :

$action=getvar("a");
if (!$action) $action="start";

if (!$dir=getvar("dir")) $dir = realpath('./');
$dir=str_replace("\\","/",$dir);
if (!$url=getvar("url")) $url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
$url = str_replace("/install.php","",$url);

$IBOARD=1;
if (file_exists($dir."/config/".$GLOBALS['inst_configfile'].".php.def") && filesize($dir."/config/".$GLOBALS['inst_configfile'].".php.def")>0) {
  require_once($dir."/config/".$GLOBALS['inst_configfile'].".php.def");
  if (!$GLOBALS[$GLOBALS['inst_versionvar']]) $GLOBALS[$GLOBALS['inst_versionvar']]=200;
}
if (file_exists($dir."/config/".$GLOBALS['inst_configfile'].".php") && filesize($dir."/config/".$GLOBALS['inst_configfile'].".php")>0) {
  require_once($dir."/config/".$GLOBALS['inst_configfile'].".php");
  if (!$GLOBALS[$GLOBALS['inst_versionvar']]) $GLOBALS[$GLOBALS['inst_versionvar']]=200;
}

if (file_exists($dir."/config/database.php")) require_once($dir."/config/database.php");
elseif (file_exists($dir."/database.php")) require_once($dir."/database.php");

if ($action=="go") go_message();

if ($action=="more") phpinfo();
else {
  common_start();
  server_info();

  if ($action=="start") start_install();
  elseif ($action=="new1") new_install1();
  elseif ($action=="new2") new_install2();
  elseif ($action=="update") update_forum();
  elseif ($action=="clear") delete_forum();
  elseif ($action=="config") config_forum();
  elseif ($action=="restore") restore_forum();
  elseif ($action=="do_restore") do_restore_forum();
  elseif ($action=="do_config") do_config_forum();

  if ($GLOBALS['link'])  db_close($GLOBALS['link']);

  common_end();
}
exit();

function start_install() {
  if ($GLOBALS[$GLOBALS['inst_versionvar']]) install_prev();
  else install_noprev();
}

//    

/*function zip_expand() {
  $dir=$GLOBALS['dir'];
  echo "  iboard2.zip";
  if (file_exists("iboard2.zip")) {
   $zip=zip_open("iboard2.zip");
   while ($zip_file=zip_read($zip)) {
     zip_entry_open($zip,$zip_file);
     $name = zip_entry_name($zip_file);
     $size=zip_entry_filesize($zip_file);
     $buffer=zip_entry_read($zip_file,$size);
     $file=fopen($dir."/".$name,"w") or global_error("    ".$name);
     fwrite($file,$buffer,$size);
     fclose($file);
     zip_entry_close($zip_file);
   }
   zip_close($zip);
   echo "- Ok<br>";
  }
  else echo("- <br>");
} */

function file_check() {
  $dir=$GLOBALS['dir'];
  echo("<br><b> :</b><br>");

  if (file_exists($dir."/list.dat")) {
    $file=fopen($dir."/list.dat","r") or global_error("    $dir/list.dat. ,     .");
    while (!feof($file)) {
      $data = fgets($file);
      if ($data) {
        list($filename,$size)=explode("|",$data);
        if (file_exists($dir."/".$filename)) {
          if (filesize($dir."/".$filename)==$size) echo " $filename - Ok<br>";
          else { echo "<p> $filename - <font color=red>  !</font><br>"; $result = 2; }
        }
        else { echo "<p> $filename - <font color=red> !</font><br>"; $result = 1; }
      }
    }
    fclose($file);
  }
  return $result;
}

function check_configs() {
  $dir=$GLOBALS['dir'];

  if (is_array($GLOBALS['inst_writeable'])) foreach ($GLOBALS['inst_writeable'] as $curfile) {
    echo "    $curfile - ";    
    if (is_writable($dir."/".$curfile)) echo "Ok<br>";
    else global_error("   ");
  }

  if (is_array($GLOBALS['inst_deffiles'])) foreach ($GLOBALS['inst_deffiles'] as $curfile) {
   create_file($dir."/".$curfile);
  }
}

function connect_database() {
  $IBOARD=1;
  if (file_exists("config/database.php")) require("config/database.php");
  elseif (file_exists("database.php")) require("database.php");
  if (getvar("DBdriver")) $DBdriver=getvar("DBdriver");
  if (getvar("DBhost")) $DBhost=getvar("DBhost");
  if (getvar("DBusername")) $DBusername=getvar("DBusername");
  if (getvar("DBpassword")) $DBpassword=getvar("DBpassword");
  if (getvar("DBname")) $DBname=getvar("DBname");
  if (getvar("DBcompress")) $DBname=getvar("DBcompress");
  echo "    - ";
  if (!file_exists($GLOBALS['dir']."/db/".$DBdriver.".php")) global_error("    db/".$DBdriver.".php");
  require_once($GLOBALS['dir']."/db/".$DBdriver.".php");
  echo "Ok<br>";
  echo "    - ";
  $GLOBALS['link']=db_connect($DBhost,$DBusername,$DBpassword);
  echo "Ok<br>";
  echo "   - ";
  db_select_db($DBname,$GLOBALS['link']);
  echo "Ok<br>";
}

function process_sql($file) {
  $fh=fopen($GLOBALS['dir']."/db/".$file,"r") or global_error(":        !");
  $buffer="";
  while (!feof($fh)) $buffer.=fgets($fh);
  fclose($fh);
  $buffer.="\n";
  $buffer=str_replace("\r","",$buffer);
  $prefix=$GLOBALS['DBprefix'];
  if (!$prefix) $prefix=getvar("DBprefix");
  $buffer=str_replace("prefix_",$prefix,$buffer);
  $sqlarray=split(";\n",$buffer);
  $link=$GLOBALS['link'];
  foreach ($sqlarray as $sql) {
    $sql=trim(str_replace("\n","",$sql));
    if ($sql) db_query($sql,$link);
  }
}

function process_sql_increment($file,$mode) {
  $open=$mode."open";
  $read=$mode."read";
  $close=$mode."close";

  $fh=call_user_func($open,$file,"rb") or global_error(":       !");
  $buflen=16*1024; //     16 Kb
  $buffer="";
  $link=$GLOBALS['link'];
  while ($buffer.=call_user_func($read,$fh,$buflen)) {
    $buffer=str_replace("\r","",$buffer);
    $pos=strpos($buffer,";\n");
    while ($pos!==false) {
      $sql = trim(substr($buffer,0,$pos+1));
      $prefix=$GLOBALS['DBprefix'];
      if (!$prefix) $prefix=getvar("DBprefix");
      $sql=str_replace("prefix_",$prefix,$sql);
      if ($sql) db_query($sql,$link);
      $buffer=substr($buffer,$pos+2);
      $pos=strpos($buffer,";\n");
    }
  }
  $sql = $buffer;
  if ($sql) db_query($sql,$link);
  call_user_func($close,$fh);
}

function save_config_file() {
  $file=$GLOBALS['inst_configfile'];
  echo ("   $file - ");
  $fh=fopen($GLOBALS['dir']."/config/$file","w");
  if (!$fh) global_error("    $file");

  $keys = preg_grep("/".$GLOBALS['inst_configprefix']."/",array_keys($GLOBALS));
  foreach ($keys as $curkey) {
    fputs($fh,"\$$curkey=\"".addslashes($GLOBALS[$curkey])."\";\n");
  }
  fputs($fh,"?>");
  fclose($fh);
  echo "Ok<br>";
}

function save_database_file() {
  echo ("    database.php - ");
  $dir=$GLOBALS['dir'];
  $fh = fopen($dir."/config/database.php","w") or global_error("    database.php");
  fputs($fh,"<? if (!\$IBOARD) global_error(\"Hack attempt!\");\n");
  fputs($fh,"\$DBhost=\"".getvar("DBhost")."\";\n");
  fputs($fh,"\$DBusername=\"".getvar("DBusername")."\";\n");
  fputs($fh,"\$DBpassword=\"".getvar("DBpassword")."\";\n");
  fputs($fh,"\$DBname=\"".getvar("DBname")."\";\n");
  fputs($fh,"\$DBprefix=\"".getvar("DBprefix")."\";\n");
  fputs($fh,"\$DBpersist=\"".getvar("DBpersist")."\";\n");
  fputs($fh,"\$DBdriver=\"".getvar("DBdriver")."\";\n");
  fputs($fh,"\$DBcompress=\"".getvar("DBcompress")."\";\n?>");
  fclose($fh);
  echo "Ok<br>";
}

function check_pass() {
  if (getvar("syspass1")!=getvar("syspass2")) global_error("   Admin     ");
}

function set_root_pass() {
  echo "   Admin - ";
  $password = md5(getvar("syspass1"));
  $trash = rand();
  $newkey=substr(md5($trash),0,rand() % 6 + 6);
  $link=$GLOBALS['link'];
  $sql="UPDATE ".getvar("DBprefix")."User SET u__password=\"".addslashes($password)."\", u_encrypted=1, u__key=\"$newkey\" WHERE u_id=2";
  db_query($sql,$link);

  $GLOBALS['salt'] = rand();
  if ($GLOBALS['opt_secbrowser']) $GLOBALS['crypt_pass']=crypt($newkey.$_SERVER['HTTP_USER_AGENT'].$password,$GLOBALS['salt']);
  else $GLOBALS['crypt_pass']=crypt($newkey.$password,$GLOBALS['salt']);

  echo("Ok<br>");
}

function create_file($filename) {
  echo("  $filename ");
  $dir=$GLOBALS['dir'];
  $subdir=$dir."/".dirname($filename);
  if (file_exists($dir."/$filename") && !is_writable($dir."/$filename")) global_error(" - :    !");
  elseif (!file_exists($dir."/$filename") && file_exists($dir."/".$filename.".def")) {
    move($dir."/".$filename.".def",$dir."/$filename");
    echo "-     <br>";
  }
  elseif (!file_exists($dir."/$filename")) {
    if (!is_writable($subdir)) global_error("-      ,   $subdir    ");
    $fh=fopen($dir."/$filename","w");
    fclose($fh);
    chmod($dir."/$filename",0644);
    echo "- Ok<br>";
  }
  else echo "- Ok<br>";
}

//  

function new_install1() {
  process_start();
//  zip_expand();
  $check=file_check();

  process_result($check);
  check_configs();
  process_end();
  db_params_form("new2");
}

function new_install2() {
  process_start();
  check_configs();
  check_pass();
  connect_database();
  echo "      - ";
  db_test();
  echo "Ok<br>";
  echo "   XPDK - ";
  $dbfile1 = getvar("DBdriver").".sql";
  process_sql($dbfile1);
  echo "Ok<br>";
  echo "        - ";
  $dbfile1 = getvar("DBdriver")."_2.sql";
  process_sql($dbfile1);
  save_config_file();
  save_database_file();
  create_templates();
  set_root_pass();
  process_goto_last();
  process_end();
}

function update_forum() {
  process_start();
  check_configs();
  if (file_exists($GLOBALS['dir']."/iboard.php")) copy_configs();
  connect_database();
  echo "      - ";
  db_test();
  echo "Ok<br>";
  echo "    - ";
  $dbfile1 = $GLOBALS['DBdriver'].$GLOBALS[$GLOBALS['inst_versionvar']].".sql";
  process_sql($dbfile1);
  echo "Ok<br>";
  save_config_file();
  process_goto_last();
  process_end();
}

function delete_forum() {
  process_start();
  check_configs();
  connect_database();
  echo "    - ";
  process_sql("drop.sql");
  echo "Ok<br>";
  process_end();
}

function config_forum() {
  db_params_form("do_config");
}

function do_config_forum() {
  process_start();
  check_configs();
  check_pass();
  connect_database();
  save_config_file();
  save_database_file();
  set_root_pass();
  process_goto_last();
  process_end();
}

function restore_forum() {
  $dh=opendir($GLOBALS['dir']."/temp/");
  while ($file=readdir($dh)) {
    if (is_file($GLOBALS['dir']."/temp/".$file)) {
      $fsize=filesize($GLOBALS['dir']."/temp/".$file);
      $buffer.="<a href=\"install.php?a=do_restore&bfile=$file\">$file</a> (".intval($fsize/1024)." Kb)<br>";
    }
  }
  closedir($dh);
  restore_form($buffer);
}

function do_restore_forum() {
  process_start();
  echo "       - ";
  if ($filename=getvar('bfile')) {
    if (!file($GLOBALS['dir']."/temp/".$filename)) echo "   !";
    $filename=$GLOBALS['dir']."/temp/".$filename;
  }
  else {
    if (is_uploaded_file($_FILES['backup']['tmp_name'])) global_error("  ");
    $filename=$_FILES['backup']['tmp_name'];
  }
  $mode=getvar('mode');
  if (!$mode) $mode="auto";
  if ($mode=="auto") {
    if (substr($filename,".gz")!==false) $mode="gz";
    elseif (substr($filename,".bz")!==false) $mode="bz";
    else $mode="f";
  }
  echo "Ok.<br>";
  echo "   - ";
  if ($mode=="gz") echo "GZIP.<br>";
  elseif ($mode=="bz") echo "BZIP2.<br>";
  else echo " .<br>";
  connect_database();
  echo "      - ";
  process_sql_increment($filename,$mode);
  echo "Ok.<br>";
  echo "<b>   !</b><br>";
  process_goto_last();
  process_end();
}

function go_message() {
 if ($_POST['crypt_pass']) {
   session_name("IB2XP");
   session_start();
   $_SESSION['uid']="2";
   $_SESSION['salt']=$_POST['salt'];
   $_SESSION['password']=$_POST['crypt_pass'];
 }
 header("Location: ".$GLOBALS['url']."/admin/index.php?m=basic&a=opt_edit");
 exit();
}

function global_error($msg) {
  echo("<font color=#FF0000><b>!</b> $msg</td></tr></table>");
  common_end();
  exit();
}

//  

function common_start() { ?>
<html><head><title> Intellect Board
</title>
<link rel="stylesheet" href="styles.css" type="text/css">
<body bgcolor="#808080"><br><div style="text-align: left">
<table align=center class="title"><tr><td>
<H1><?=$GLOBALS['inst_projtitle'];?></H1>
<H2><?=$GLOBALS['inst_projdescr'];?></H2>
</td></tr></table>
<table align=center class="outertable" cellspacing=1 cellpadding=6><tr><td>
<? }

function server_info() { ?>
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead">  </td></tr>
<tr class="basictable"><td>
 : <?=$_SERVER["SERVER_NAME"];?> (<?=$_SERVER["HTTP_HOST"];?>)<br>
Web-: <?=$_SERVER["SERVER_SOFTWARE"];?><br>
 PHP: <? echo phpversion();
 if (version_compare(phpversion(),"4.1.0")==-1) {
   echo "<font color=red> -    4.1.0</font>"; }
   else { echo " - Ok"; } ?><br>
  : <?=$_SERVER["DOCUMENT_ROOT"];?><br>
,    : <?=$GLOBALS['dir'];?><br>
   : <?=date("D, d F Y H:i");?><br>
     <?=get_current_user();?> (<?=getmyuid();?>)<br>
<a href="install.php?a=more"></a><br>
</td></tr></table><br>
<? }

function install_prev() { ?>
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead"> </td></tr>
<tr class="basictable"><td><br><br>       Intellect Board - <?=sprintf("%.2f",$GLOBALS[$GLOBALS['inst_versionvar']]/100);?>
<br><br><br></td></tr>
<tr><td class="tablehead"><form action="install.php" method=GET>
<input type=hidden name=a value=config><input type=submit style="width:300 px" value=""></form></td></tr>
<? if ($GLOBALS[$GLOBALS['inst_versionvar']]<$GLOBALS['newversion']) { ?>
<tr><td class="tablehead"><form action="install.php" method=GET>
<input type=hidden name=a value=update><input type=submit style="width:300 px" value=""></form></td></tr>
<? } ?>
<tr><td class="tablehead"><form action="install.php" method=GET>
<input type=hidden name=a value=delete><input type=submit style="width:300 px" value=""></form></td></tr>
<tr><td class="tablehead"><form action="install.php" method=GET>
<input type=hidden name=a value=restore><input type=submit style="width:300 px" value="   "></form></td></tr>
</table><br>
<? }

function install_noprev() { ?>
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead"> </td></tr>
<tr class="basictable"><td><br><br>     Intellect Board  <br><br></td></tr>
<tr><td class="tablehead"><form action="install.php" method=GET>
<input type=hidden name=a value=new1><input type=submit style="width:300 px" value="  "></form></td></tr>
</table><br>
<? }


function process_start() { ?>
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead"> </td></tr>
<tr class="basictable"><td><br>
<? }

function process_result($result) {
  if ($result==0) echo ("<b>   !</b><br><br>");
  elseif ($result==1) {
    echo ("<font color=red>:     !</font><br>");
    echo (",    ,   ,    .<br>");
    echo ("   ,         .<br><br>");
  }
  elseif ($result==2) {
    echo ("<font color=red>:            list.dat!</font><br>");
    echo (",      ,   ,    .<br>");
    echo ("   ,         .<br><br>");
  }
}

function process_goto_last() { ?>
<br><br>
<table width=100% align=center><tr><td align=center>
<form action="install.php" method=POST>
<input type=hidden name=a value=go><input type=hidden name=salt value="<?=$GLOBALS['salt'];?>">
<input type=hidden name=crypt_pass value="<?=$GLOBALS['crypt_pass'];?>">
<input type=submit value="       ">
</td></tr></table></form>
<? }

function process_end() { ?>
<br></td></tr></table><br>
<? }

function db_params_form($newaction) { ?>
<form action="install.php" method=POST>
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead" colspan=2>  </td></tr>
<tr class="basictable"><td>   :
</td><td><input type=text name=dir size=40 maxlength=255 value="<?=$GLOBALS['dir'];?>"></td></tr>
<tr class="basictable"><td>URL :
</td><td><input type=text name=url size=40 maxlength=255 value="<?=$GLOBALS['url'];?>"></td></tr>
<tr class="basictable"><td width=50%> SQL-:
</td><td><select name=DBdriver><option value="mysql">MySQL</select></td></tr>
<tr class="basictable"><td> SQL-:
</td><td><input type=text name=DBhost size=40 maxlength=255 value="<?=$GLOBALS['DBhost'];?>"></td></tr>
<tr class="basictable"><td>      :
</td><td><input type=text name=DBusername size=40 maxlength=255 value="<?=$GLOBALS['DBusername'];?>"></td></tr>
<tr class="basictable"><td>     :
</td><td><input type=password name=DBpassword size=40 maxlength=255 value="<?=$GLOBALS['DBpassword'];?>"></td></tr>
<tr class="basictable"><td>  :
</td><td><input type=text name=DBname size=40 maxlength=255 value="<?=$GLOBALS['DBname'];?>"></td></tr>
<tr class="basictable"><td>    :
</td><td><input type=radio name=DBpersist value=1 checked> &nbsp;
<input type=radio name=DBpersist value=""></td></tr>
<tr class="basictable"><td>     :<br>
<span class="descr"> ,       localhost.</span>
</td><td><input type=radio name=DBcompress value=1> &nbsp;
<input type=radio name=DBcompress value="" checked></td></tr>
<tr class="basictable"><td>    :
</td><td><input type=text name=DBprefix size=40 maxlength=255 value="<?=$GLOBALS['DBprefix'];?>"></td></tr>
<tr class="basictable"><td>  Admin:
</td><td><input type=password name=syspass1 size=40 maxlength=255></td></tr>
<tr class="basictable"><td> :
</td><td><input type=password name=syspass2 size=40 maxlength=255></td></tr>
<tr><td class="tablehead" colspan=2><input type=hidden name=a value="<?=$newaction;?>">
<input type=submit value=" ">
</td></tr></table></form><br>
<? }

function restore_form($buffer) { ?>
<form action="install.php" method=POST enctype="multipart/form-data">
<table class="innertable" width=100% cellspacing=1><tr><td class="tablehead" colspan=2>      </td></tr>
<tr class="basictable"><td>   temp :</td>
<td><?=$buffer;?></td></tr>
<tr class="basictable"><td>      :</td>
<td><input type=file name=backup size=40 maxlength=255></td></tr>
<tr class="basictable"><td> :</td>
<td><input type=radio name=mode value=auto checked> &nbsp;
<input type=radio name=mode value=gz>GZIP &nbsp;
<input type=radio name=mode value=gz>BZIP2 &nbsp;
<input type=radio name=mode value=gz> 
</td></tr>
<tr class="basictable"><td colspan=2>:     ,          .    ,    " "       .<br>
:    -   ,          .</td></tr>
<tr><td class="tablehead" colspan=2><input type=hidden name=a value="do_restore">
<input type=submit value="  ">
</td></tr></table></form><br>
<? }

function common_end() { ?>
</td></tr></table>
<table align=center class="copyright"><tr><td>
         <a class="inverse" href="http://xpdk.openproj.ru">XPDK</a><br>
&copy; 2006, XXXX Pro, <a class="inverse" href="http://openproj.ru" target=_blank>  </a><br>
</td></tr></table>
</body></html>
<? }