<? /*

XXXXPro's PHP Developer Kit (XPDK)

(c) 2005, XXXX Pro, United Open Project
Visit us online: http://openproj.ru
*/

function &getvar($name) {
  if (strpos($name,"_text")!==false && $name!="pv_text" && $name!="pm_text") {
      if (isset($_GET[$name])) $tmp = stripslashes($_GET[$name]);
      elseif (isset($_POST[$name])) $tmp= stripslashes($_POST[$name]);
  }
  else {
      if (isset($_GET[$name])) $tmp = htmlspecialchars(stripslashes($_GET[$name]));
      elseif (isset($_POST[$name])) $tmp= htmlspecialchars(stripslashes($_POST[$name]));
  }
  $tmp=db_slashes($tmp);
  return $tmp;
}

function &build_select($sql,$value="") {
    $res = db_query($sql,$GLOBALS['link']);
    $tmp = "";
    while ($tmpdata=db_fetch_row($res)) {
        if ($tmpdata[0]==$value) $tmp.="<option value=\"".$tmpdata[0]."\" selected>".$tmpdata[1];
        else $tmp.="<option value=\"".$tmpdata[0]."\">".$tmpdata[1];
    }
    db_free_result($res);
    return $tmp;
}

function &build_sql($prefix) {
  $tmp = "";
  $prefixlen = strlen($prefix);
  foreach ($_POST as $name=>$value) {
      if (substr($name,0,$prefixlen)==$prefix && strpos($name,"__")===false && $name!=$prefix."_id") {
           if (strpos($name,"_text")===false) $value=htmlspecialchars($value);
           else $value=db_slashes($value);
         if ($tmp) $tmp.=", ";
           $tmp .= "$name=\"".$value."\"";
         }
  }
  return $tmp;
}

function &build_sql_all($prefix) {
  $tmp = "";
  $prefixlen = strlen($prefix);
  foreach ($_POST as $name=>$value) {
      if (substr($name,0,$prefixlen)==$prefix) {
         if ($tmp) $tmp.=", ";
         $tmp .= "$name=\"".db_slashes($value)."\"";
      }
  }
  return $tmp;
}

function check($expr) {
    if ($expr>0) echo "checked";
}

function &set_select($select,$value) {
    $select=preg_replace("/selected\s+>/is","",$select);
    $select=preg_replace("/<option\s+value=\"?$value\"?\.*?>/is","<option value=\"$value\" selected>",$select);
    echo $select;
}

function &build_pages($count,$start,$perpage,$ref) {
    $reflen = strlen($ref);
    if ($ref[$reflen-1]!="?" && $ref[$reflen-1]!="&") {
        if (!strpos($ref,"?")) $ref.="?";
        else $ref.="&";
    }
    if (!$perpage) $perpage=10;
    $numpages = ceil($count/$perpage);
    if ($numpages>1 || $start>0) {
        $pages = MSG_pages;
        $number=0;
        for ($i=1; $i<=$numpages; $i++) {
            if ($number!=$start || $start=="all") $pages.="<a href=\"$ref"."st=".$number."\">$i</a> ";
            else $pages.="$i ";
            $number+=$perpage;
      }
      if ($start=="all") $pages.="#";
      else $pages.="<a href=\"$ref"."st=all\">#</a> ";
  }
  return $pages;
}

function &getip() {
    $ip;
    if     ($_SERVER["HTTP_CLIENT_IP"])       $ip = $_SERVER["HTTP_CLIENT_IP"];
    elseif ($_SERVER["HTTP_X_FORWARDED_FOR"]) $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    elseif ($_SERVER["HTTP_FORWARDED_FOR"])   $ip = $_SERVER["HTTP_FORWARDED_FOR"];
    else   $ip = $_SERVER["REMOTE_ADDR"];
    $ip = str_replace(";",",",$ip);
    if (strpos($ip,",")!==false) $ip=substr($ip,0,strpos($ip,",")-1);
    return $ip;
}

function &build_date_field($field,$time) {
    $tmp = "<input type=text name=".$field."_day size=2 maxlength=2 value=\"".date("d",$time)."\">.";
    $tmp .= "<input type=text name=".$field."_mon size=2 maxlength=2 value=\"".date("n",$time)."\">.";
    $tmp .= "<input type=text name=".$field."_year size=4 maxlength=4 value=\"".date("Y",$time)."\">";
    return $tmp;
}

function &get_date_field($field) {
    $tmp = mktime(0,0,0,getvar($field."_mon"),getvar($field."_day"),getvar($field."_year"));
    return $tmp;
}

function &iptonum($ip) {
    $ipdata=explode(".",$ip);
    $num=0;
    for($i=0;$i<4;$i++) $num=$num * 256+floatval($ipdata[$i]);
    return $num;
}

function &numtoip($num) {
    $str=floor($num/(256*256*256)).".";
    $num = ($num/(256*256*256)-floor($num/(256*256*256)))*256*256*256;
    $str.=floor($num/(256*256)).".";
    $num = $num % (256*256);
    $str.=floor($num /256).".";
    $num = $num % (256);
    $str.=$num;
    return $str;
}

function textarea($text) {
   $text=str_replace("<","&lt;",$text);
   $text=str_replace(">","&gt;",$text);
   return stripslashes($text);
}

function& sql_array($sql) {
  return db_sqlarray($sql);
}

function& db_sqlarray($sql) {
   $link=$GLOBALS['link'];
   $res=db_query($sql,$link);
   $tmpdata=array();
   while ($tmp=db_fetch_array($res)) array_push($tmpdata,$tmp); 
   db_free_result($res);
   return $tmpdata;   
}

function get_text($text) {
  return $text;
}

function get_formdata($name) {
   $sql = "SELECT * FROM  ".$GLOBALS['DBprefix']."formdata WHERE fd_formname=\"$name\" ORDER BY fd_sortfield";
   return sql_array($sql);
}

function get_actionlist($name) {
   $sql = "SELECT * FROM ".$GLOBALS['DBprefix']."listaction WHERE ls_listname=\"$name\" ORDER BY ls_sortfield";
   return sql_array($sql);
}

function get_menuitems($name,$tag,$level) {
  $sql="SELECT * FROM ".$GLOBALS['DBprefix']."menu WHERE mn_menuname=\"$name\" AND (mn_tag=0 OR mn_tag=\"$tag\") AND mn_level<=\"$level\" ORDER BY mn_sortfield";
  return sql_array($sql);  
}

function build_form($name,$data,$title,$sbmtext,$extdata=array()) {
   $intable=$GLOBALS['ds_intable'];
   $base_class=$GLOBALS['ds_basic'];
   $title_class=$GLOBALS['ds_head'];
  
   $files=0;
   $buffer.="<table class=\"$intable\" width=100% cellspacing=1 cellpadding=0>";
   $buffer.="<tr><td class=\"".$title_class."\" colspan=2>";
   $buffer.=$title."</td></tr>";
   $formdata=get_formdata($name);
   foreach ($formdata as $fdata) {
     if (!isset($data[$fdata['fd_name']]) && !$extdata[$fdata['fd_name']]) $data[$fdata['fd_name']]=$fdata['fd_defvalue'];
     if ($fdata['fd_jscheck']) {
       $js1.="if ((tx=".$fdata['fd_name']."_chk(self))!=\"\" && f) {alert(tx); self.".$fdata['fd_name'].".focus(); f=false;}\n";
       $js2.="function ".$fdata['fd_name']."_chk(self) {\n".$fdata['fd_jscheck']."\nreturn \"\";}\n";
       $onblur="onBlur=\"scl(".$fdata['fd_name']."_chk(this.form),this)\"";
     }
     else $onblur="onBlur=\"scl('',this)\"";
     if ($fdata['fd_type']!=7 && $fdata['fd_type']!=8) $buffer.="<tr class=\"".$base_class."\"><td>".get_text($fdata['fd_text'])."</td><td>";
     if ($fdata['fd_type']==0 || $fdata['fd_type']==1) { // text  password
       if ($fdata['fd_type']==0) $type="type=text";
       else $type="type=password";
       if (!$startelm) $startelm=$fdata['fd_name'];
       $buffer.="<input $type $onblur name=\"".$fdata['fd_name']."\" size=".$fdata['fd_size']." maxlength=".$fdata['fd_maxlen']." value=\"".htmlspecialchars($data[$fdata['fd_name']])."\">";
     }
     elseif ($fdata['fd_type']==2) { // file
       $buffer.="<input type=file $onblur name=\"".$fdata['fd_name']."\" size=".$fdata['fd_size'].">";
       $files++;
     }
     elseif ($fdata['fd_type']==3) { // checkbox
       if ($data[$fdata['fd_name']]) $checked=" checked";
       else $checked="";
       $buffer.="<input type=checkbox name=\"".$fdata['fd_name']."\" value=\"".$fdata['fd_values']."\"$checked>";
     }
     elseif ($fdata['fd_type']==4) { //textarea
       if (!$startelm) $startelm=$fdata['fd_name'];
       $buffer.="<textarea $onblur name=\"".$fdata['fd_name']."\" cols=\"".$fdata['fd_size']."\" rows=\"".$fdata['fd_rows']."\">".textarea($data[$fdata['fd_name']])."</textarea>";
     }
     elseif ($fdata['fd_type']==5) { //radio
       $values = explode("|",$fdata['fd_valuelist']);
       $descr = explode("|",$fdata['fd_commentlist']);
       if (is_array($values)) for ($i=0; $i<count($values); $i++) {
         if ($data[$fdata['fd_name']]==$values[$i]) $checked=" checked";
         else $checked="";
         $buffer.= "<input type=radio name=\"".$fdata['fd_name']."\" value=\"".$values[$i]."\"$checked>";
         $buffer.= " ".get_text($descr[$i]);
         if (count($values)>3) $buffer.="<br>";
         else $buffer.=" &nbsp; ";
       }
     }
     elseif ($fdata['fd_type']==6) { //select
       $buffer.="<select name=\"".$fdata['fd_name']."\">";       
       if (!$extdata[$fdata['fd_name']]) {
         $values = explode("|",$fdata['fd_valuelist']);
         $descr = explode("|",$fdata['fd_commentlist']);
         if (is_array($values)) for ($i=0; $i<count($values); $i++) {
           if ($data[$fdata['fd_name']]==$values[$i]) $checked=" selected";
           else $checked="";
           $buffer.= "<option value=\"".$values[$i]."\"$checked>";
           $buffer.= get_text($descr[$i]);
         }
       }
       else $buffer.=$extdata[$fdata['fd_name']];
       $buffer.="</select>";
     }
     elseif ($fdata['fd_type']==7) { // hidden
       $hiddens.="<input type=hidden name=\"".$fdata['fd_name']."\" value=\"".htmlspecialchars($data[$fdata['fd_name']])."\">";
     }
     if ($fdata['fd_type']==8) $buffer.="<tr><td colspan=2 class=\"$title_class\">".get_text($fdata['fd_text'])."</td></tr>";
     if ($fdata['fd_type']==9) {
       if (!is_numeric($data[$fdata['fd_name']])) $data[$fdata['fd_name']]=0;
       $buffer.=build_date_field($fdata['fd_name'],$data[$fdata['fd_name']]);
     }
     if ($fdata['fd_type']!=7 && $fdata['fd_type']!=8) $buffer.="</td></tr>";     
   }
   $buffer.="<tr><td class=\"".$title_class."\" colspan=2>";
   $action=$GLOBALS['action']; 
   $module=$GLOBALS['module'];
   $js1="<script><!--\nfunction scl(tx,elm) {\nif (tx==\"\") {elm.style.borderColor=\"".$GLOBALS['color_error']."\"} else {elm.style.borderColor=\"".$GLOBALS['color_ok']."\"}\n}\n".
   "function check(self) {\nf=true;\n".$js1."\nreturn f;}\n$js2\n//---></script>\n";
   $buffer.=$hiddens;
   $buffer.="<input type=hidden name=a value=\"$action\">";
   $buffer.="<input type=hidden name=m value=\"$module\">";
   $buffer.="<input type=submit style=\"width: ".$GLOBALS['ds_buttonwidth']."\" name=sbm value=\"$sbmtext\">";
   $buffer.="</td></tr></table></form>";
   if ($files==0) $buffer="$js1\n$onload<form name=\"$name\"  method=POST onSubmit=\"return check(this);\">".$buffer;
   else $buffer="<form name=\"$name\" method=POST enctype=\"multipart/form-data\" onSubmit=\"return check(this);\">".$buffer;
   $buffer.="<script><!--\ndocument.$name.$startelm.focus();\n//--></script>";
   return $buffer;
}

function process_form($name) {
  $formdata=get_formdata($name);
  foreach ($formdata as $fdata) {
     if ($fdata['fd_type']==9) $tmpdata=get_date_field($fdata['fd_name']);
     elseif (isset($_POST[$fdata['fd_name']])) $tmpdata=$_POST[$fdata['fd_name']];
     else $tmpdata=$_GET[$fdata['fd_name']];
     if ($fdata['fd_html']==0) $tmpdata=htmlspecialchars($tmpdata);
     $data[$fdata['fd_name']]=$tmpdata;
     if ($fdata['fd_phpcheck']) {
       $checkfunc=create_function('&$data',$fdata['fd_phpcheck']);
       $checkfunc($data);
     }
   }
   return $data;
}

function db_insert($table,$data,$prefix="") {
  foreach ($data as $key=>$value) {
    if (substr($key,0,strlen($prefix))==$prefix) {
      $columns[]=$key;
      $values[]="\"".addslashes($value)."\"";
    }
  }
  $collist=join(",",$columns);
  $valuelist=join(",",$values);
  $sql = "INSERT INTO ".$GLOBALS['DBprefix']."$table ($collist) VALUES ($valuelist)";
  $res=db_query($sql,$GLOBALS['link']);
  return db_insert_id($res);
}

function db_update($table,$data,$condition,$prefix="") {
  foreach ($data as $key=>$value) {
    if (substr($key,0,strlen($prefix))==$prefix) {
      $datapair[]="$key=\"".addslashes($value)."\"";
    }
  }
  $sqldata=join(", ",$datapair);
  $sql = "UPDATE ".$GLOBALS['DBprefix']."$table SET $sqldata WHERE $condition";
  $res=db_query($sql,$GLOBALS['link']);
}

function build_list($name,$data,$idname,$textname,$title,$defaction="",$chtext="",$morefields=NULL) {
  $link=$GLOBALS['link'];
  $intable=$GLOBALS['ds_intable'];
  $base_class=$GLOBALS['ds_basic'];
  $title_class=$GLOBALS['ds_head'];
  $buffer="";
  if ($chtext) {
    $buffer.="<form action=\"".$GLOBALS['basefile']."\" method=POST>";
  }
  $buffer.="<table class=\"$intable\" width=100% cellpadding=0 cellspacing=1>";
  $buffer.="<tr><td class=\"$title_class\" colspan=".(count($morefields)+2).">$title</td></tr>";
/*  if ($chtext) {
    $buffer.="<tr><td width=5% class=\"$title_class\"><input type=checkbox></td></tr>";
    $buffer.="<td width=50% class=\"$title_class\"></td>";
    $buffer.="<td width=45% class=\"$title_class\"></td></tr>"; //</table></tr></td>
  }
  else {
    $buffer.="<td width=50% class=\"$title_class\">$title</td>";
    $buffer.="<td width=50% class=\"$title_class\"></td></tr>"; //</table></td></tr>    
  } */
  $actionlist=get_actionlist($name);
  $module=$GLOBALS['module'];  
  foreach ($data as $curdata) {
    $buffer.="<tr class=\"$base_class\">";
    if ($chtext) $buffer.="<td><input type=checkbox name=\"".$idname."[".$curdata[$idname]."]\" value=\"".$curdata[$idname]."\"></td>";
    $lnk=$idname."=".$curdata[$idname];
    if (!$defaction) $buffer.="<td>".$curdata[$textname]."</td>";
    else $buffer.="<td><a href=\"".$GLOBALS['basefile']."?m=$module&a=$defaction&$lnk\">".$curdata[$textname]."</a></td>";
    if (is_array($morefields)) foreach ($morefields as $cf) $buffer.="<td>".$curdata[$cf]."</td>";
    $buffer.="<td>";
    foreach ($actionlist as $curaction) {
      if ($curaction['ls_confirm']) $confirmjs="onClick=\"return confirm('".$curaction['ls_confirmtext']."')\"";
      else unset($confirmjs);
      $buffer.="<a $confirmjs href=\"".$GLOBALS['basefile']."?m=$module&a=".$curaction['ls_action']."&$lnk\">".get_text($curaction['ls_comment'])."</a> &nbsp; ";
    }
    $buffer.="</td></tr>";
  }
  if ($chtext) { 
    $action=$GLOBALS['action'];
    $buffer.="<tr><td class=\"$title_class\" colspan=3><input type=hidden name=m value=\"$module\">";
    $buffer.="<input type=hidden name=a value=\"$action\"><input type=submit style=\"width: ".$GLOBALS['ds_buttonwidth']."\" name=sbm value=\"".get_text($chtext)."\">";
    $buffer.="</td></tr></table></form>";
  }
  else $buffer.="</table><br>";
  return $buffer;
}

function  build_horiz_menu($name,$tag=0,$level=0,$prefix="",$postfix="",$separator="") {
  $link=$GLOBALS['link'];
  $intable=$GLOBALS['ds_intable'];
  $menuclass=$GLOBALS['ds_menuclass'];
  
  $menuitems = get_menuitems($name,$tag,$level);
  $buffer.="<table class=\"$intable\" width=100% cellpadding=0 cellspacing=0><tr>";
  foreach ($menuitems as $curmenu) {
    $buffer.="<td class=\"$menuclass\">$prefix"."<a href=\"".$curmenu['mn_url']."\">";
    if (!$curmenu['mn_button']) $buffer.=$curmenu['mn_text'];
    else $buffer.="<img src=\"".$curmenu['mn_button']."\" border=0 alt=\"".$curmenu['mn_text']."\">";
    $buffer.="</a>$postfix</td>";
    $buffer.=$separator;
  }
  $buffer.="</tr></table>";
  return $buffer;
}

function  build_vert_menu($name,$tag=0,$level=0,$prefix="",$postfix="",$separator="") {
  $link=$GLOBALS['link'];
  $intable=$GLOBALS['ds_intable'];
  $menuclass=$GLOBALS['ds_menuclass'];
  
  $menuitems = get_menuitems($name,$tag,$level);
  $buffer.="<table class=\"$intable\" width=100% cellpadding=0 cellspacing=0>";
  foreach ($menuitems as $curmenu) {
    $buffer.="<tr><td class=\"$menuclass\">$prefix"."<a href=\"".$curmenu['mn_url']."\">";
    if (!$curmenu['mn_button']) $buffer.=$curmenu['mn_text'];
    else $buffer.="<img src=\"".$curmenu['mn_button']."\" border=0 alt=\"".$curmenu['mn_text']."\">";
    $buffer.="</a>$postfix</td></tr>";
    $buffer.=$separator;
  }
  $buffer.="</table>";
  return $buffer;
}

function build_button($action,$title,$params,$module="",$target=FALSE) {
  if ($target) $targettext="target=_blank";  
  $buffer.="<form action=\"".$GLOBALS['basefile']."\" $targettext method=GET>";
  $buffer.="<table width=100% border=0 align=center><tr><td align=center>";
  $buffer.="<input type=hidden name=a value=\"$action\">";
  if ($module) $buffer.="<input type=hidden name=m value=\"$module\">";
  if (is_array($params)) foreach ($params as $key=>$value) $buffer.="<input type=hidden name=\"$key\" value=\"$value\">";
  $buffer.="<input type=submit style=\"width: ".$GLOBALS['ds_buttonwidth']."\" value=\"$title\">";
  $buffer.="</td></tr></table></form>";
  return $buffer;
}

function nextfield(&$data,$fieldname,$table) {
  $sql = "SELECT MAX($fieldname)+1 FROM ".$GLOBALS['DBprefix']."$table";
  $res=db_query($sql,$GLOBALS['link']);
  list($nextfield)=db_fetch_row($res);
  db_free_result($res);
  if (!$nextfield) $nextfield=1;
  $data[$fieldname]=$nextfield;
}

function db_getrow($sql) {
  $res=db_query($sql,$GLOBALS['link']);
  $data=db_fetch_array($res);
  db_free_result($res);
  return $data;
}

function message($text,$auto=0,$newlink="") { ?>
<html><head><title><?=$GLOBALS['opt_title'];?></title>
<link rel="stylesheet" href="styles.css" type="text/css">
<? if ($auto) { ?><meta http-equiv="refresh" content="1; url=<?=$newlink;?>"><? } ?>
</head>
<body bgcolor="#808080">
<table cellspacing=1 class="<?=$GLOBALS['ds_intable'];?>" width=90% align=center><tr>
<td class="<?=$GLOBALS['ds_head'];?>"><?=$text;?></td>
</tr><tr> 
<td class="<?=$GLOBALS['db_basic'];?>">  :<ul>
<li><a href="<?=$newlink;?>"> </a></li><li><a href="".$GLOBALS['basefile']."">   </a></ul></td>
</tr></table></body></html>
<? } 

