-- MySQL dump 10.10
--
-- Host: localhost    Database: xpdk
-- ------------------------------------------------------
-- Server version	5.0.15-nt
--
-- Table structure for table `prefix_formdata`
--

DROP TABLE IF EXISTS `prefix_formdata`;
CREATE TABLE `prefix_formdata` (
  `fd_id` int(10) unsigned NOT NULL auto_increment,
  `fd_formname` varchar(16) NOT NULL default '',
  `fd_name` varchar(32) NOT NULL default '',
  `fd_defvalue` varchar(255) NOT NULL default '',
  `fd_type` tinyint(3) unsigned NOT NULL default '1',
  `fd_sortfield` smallint(5) unsigned NOT NULL default '0',
  `fd_size` tinyint(3) unsigned NOT NULL default '45',
  `fd_maxlen` tinyint(3) unsigned NOT NULL default '35',
  `fd_valuelist` text NOT NULL,
  `fd_commentlist` text NOT NULL,
  `fd_jscheck` varchar(255) NOT NULL default '',
  `fd_phpcheck` varchar(255) NOT NULL default '',
  `fd_rows` tinyint(3) unsigned NOT NULL default '1',
  `fd_text` varchar(255) NOT NULL default '',
  `fd_html` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fd_id`),
  KEY `formname` (`fd_formname`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `prefix_formdata`
--


LOCK TABLES `prefix_formdata` WRITE;
INSERT INTO `prefix_formdata` VALUES (1,'formedit','fd_formname','',0,1,16,16,'','','if (self.fd_formname.value==\"\") { return \"   !\"; }','if (!$data[\'fd_formname\']) error(\"   !\");',1,' ',0),(2,'formedit','fd_name','',0,2,32,32,'','','if (self.fd_name.value==\"\") { return \'   !\'; }\r\n','if (!$data[\'fd_name\']) error(\"   !\");',1,' ',0),(3,'formedit','fd_defvalue','',0,4,40,255,'','','','',1,'  ',0),(4,'formedit','fd_type','0',5,5,45,35,'0|1|2|3|4|5|6|7|8|9','text|password|file|checkbox|textarea|radio|select|hidden|separator|','','',1,' ',0),(5,'formedit','fd_sortfield','',7,6,45,35,'','','','',1,'',0),(6,'formedit','fd_size','45',0,7,4,4,'','','','',1,'  ',0),(7,'formedit','fd_maxlen','45',0,8,4,4,'','','','',1,'     ',0),(8,'formedit','fd_valuelist','',0,9,45,255,'','','','',1,'   radio  select',0),(9,'formedit','fd_commentlist','',0,10,45,255,'','','','',1,'  ()  radio  select',0),(10,'formedit','fd_rows','1',0,11,3,3,'','','','',1,'   select  textarea',0),(11,'formedit','fd_text','',0,12,45,255,'','','','',1,'  ',0),(12,'listedit','ls_id','0',7,13,0,0,'','','','',0,'',0),(13,'listedit','ls_listname','',0,14,12,12,'','','','',1,' :',0),(14,'listedit','ls_action','',0,15,45,255,'','','','',1,',  :',0),(15,'listedit','ls_comment','',0,16,45,255,'','','','',1,' :',0),(16,'listedit','ls_sortfield','',7,17,45,45,'','','','',1,'',0),(17,'menuedit','mn_id','0',7,18,45,45,'','','','',1,'',0),(18,'menuedit','mn_menuname','',0,19,12,12,'','','','',1,' :',0),(19,'menuedit','mn_text','',0,20,45,255,'','','','',1,'  :',0),(20,'menuedit','mn_url','',0,21,45,255,'','','','',1,'  :',0),(21,'menuedit','mn_tag','',0,22,4,5,'','','','',1,'  ',0),(22,'menuedit','mn_level','',0,23,4,5,'','','','',1,'     :',0),(23,'menuedit','mn_sortfield','',7,24,45,45,'','','','',1,'',0);
UNLOCK TABLES;

--
-- Table structure for table `prefix_listaction`
--

DROP TABLE IF EXISTS `prefix_listaction`;
CREATE TABLE `prefix_listaction` (
  `ls_id` int(10) unsigned NOT NULL auto_increment,
  `ls_listname` varchar(12) NOT NULL default '',
  `ls_action` varchar(255) NOT NULL default '',
  `ls_comment` varchar(255) NOT NULL default '',
  `ls_sortfield` smallint(5) unsigned NOT NULL default '0',
  `ls_confirm` tinyint(3) unsigned NOT NULL default '0',
  `ls_confirmtext` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ls_id`),
  KEY `listname` (`ls_listname`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `prefix_listaction`
--

LOCK TABLES `prefix_listaction` WRITE;
INSERT INTO `prefix_listaction` VALUES (1,'formentries','delete_form',' ',1,1,'     ?'),(2,'listentries','delete_list',' ',2,1,'     ?'),(3,'menuentries','delete_menu','  ',3,0,'');
UNLOCK TABLES;

--
-- Table structure for table `prefix_menu`
--

DROP TABLE IF EXISTS `prefix_menu`;
CREATE TABLE `prefix_menu` (
  `mn_id` int(10) unsigned NOT NULL auto_increment,
  `mn_menuname` varchar(12) NOT NULL default '',
  `mn_text` varchar(45) NOT NULL default '',
  `mn_url` varchar(45) NOT NULL default '',
  `mn_tag` smallint(5) unsigned NOT NULL default '0',
  `mn_level` smallint(5) unsigned NOT NULL default '0',
  `mn_sortfield` smallint(5) unsigned NOT NULL default '0',
  `mn_button` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`mn_id`),
  KEY `menuname` (`mn_menuname`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `prefix_menu`
--


LOCK TABLES `prefix_menu` WRITE;
INSERT INTO `prefix_menu` VALUES (1,'mainmenu',' ','editor.php?a=list_forms',0,0,1,''),(2,'mainmenu',' ','editor.php?a=list_lists',0,0,2,''),(3,'mainmenu',' ','editor.php?a=list_menus',0,0,3,'');
UNLOCK TABLES;

--
-- Table structure for table `prefix_user`
--

DROP TABLE IF EXISTS `prefix_user`;
CREATE TABLE `prefix_user` (
  `u_id` int(10) unsigned NOT NULL auto_increment,
  `u__name` varchar(32) NOT NULL default '',
  `u__password` char(32) NOT NULL default '',
  `u__key` char(16) NOT NULL default '',
  `u__level` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`u_id`),
  UNIQUE KEY `login` (`u__name`),
  KEY `level` (`u__level`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `prefix_user`
--

LOCK TABLES `prefix_user` WRITE;
INSERT INTO `prefix_user` VALUES (1,'Guest','','',0),(2,'Admin','2aee1c40199c7754da766e61452612cc','',1000);
UNLOCK TABLES;
